TinyXML-2: tinyxml2::XMLPrinter Class Reference

TinyXML-2 10.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
tinyxml2::XMLPrinter Class Reference

`#include <tinyxml2.h>`

Inheritance diagram for tinyxml2::XMLPrinter:

## Public Member Functions
| XMLPrinter (FILE *file=0, bool compact=false, int depth=0)
void | PushHeader (bool writeBOM, bool writeDeclaration)
void | OpenElement (const char *name, bool compactMode=false)
void | PushAttribute (const char *name, const char *value)
| If streaming, add an attribute to an open element.
virtual void | CloseElement (bool compactMode=false)
| If streaming, close the Element.
void | PushText (const char *text, bool cdata=false)
| Add a text node.
void | PushText (int value)
| Add a text node from an integer.
void | PushText (unsigned value)
| Add a text node from an unsigned.
void | PushText (int64_t value)
| Add a text node from a signed 64bit integer.
void | PushText (uint64_t value)
| Add a text node from an unsigned 64bit integer.
void | PushText (bool value)
| Add a text node from a bool.
void | PushText (float value)
| Add a text node from a float.
void | PushText (double value)
| Add a text node from a double.
void | PushComment (const char *comment)
| Add a comment.
virtual bool | VisitEnter (const XMLDocument &) override
| Visit a document.
virtual bool | VisitExit (const XMLDocument &) override
| Visit a document.
virtual bool | VisitEnter (const XMLElement &element, const XMLAttribute *attribute) override
| Visit an element.
virtual bool | VisitExit (const XMLElement &element) override
| Visit an element.
virtual bool | Visit (const XMLText &text) override
| Visit a text node.
virtual bool | Visit (const XMLComment &comment) override
| Visit a comment node.
virtual bool | Visit (const XMLDeclaration &declaration) override
| Visit a declaration.
virtual bool | Visit (const XMLUnknown &unknown) override
| Visit an unknown node.
const char * | CStr () const
int | CStrSize () const
void | ClearBuffer (bool resetToFirstElement=true)

## Protected Member Functions
virtual void | PrintSpace (int depth)

## Detailed Description

Printing functionality. The XMLPrinter gives you more options than the XMLDocument::Print() method.

It can:

1. Print to memory.
2. Print to a file you provide.
3. Print XML without a XMLDocument.

Print to Memory

    XMLPrinter printer;
    doc.Print( &printer );
    SomeFunction( printer.CStr() );

Print to a File

You provide the file pointer.

    XMLPrinter printer( fp );
    doc.Print( &printer );

Print without a XMLDocument

When loading, an XML parser is very useful. However, sometimes when saving, it just gets in the way. The code is often set up for streaming, and constructing the DOM is just overhead.

The Printer supports the streaming case. The following code prints out a trivially simple XML file without ever creating an XML document.

    XMLPrinter printer( fp );
    printer.OpenElement( "foo" );
    printer.PushAttribute( "foo", "bar" );
    printer.CloseElement();

## Constructor & Destructor Documentation

## ◆ XMLPrinter()

tinyxml2::XMLPrinter::XMLPrinter | ( | FILE * | file = 0,
|  | bool | compact = false,
|  | int | depth = 0 )

Construct the printer. If the FILE* is specified, this will print to the FILE. Else it will print to memory, and the result is available in CStr(). If 'compact' is set to true, then output is created with only required whitespace and newlines.

## Member Function Documentation

## ◆ ClearBuffer()

void tinyxml2::XMLPrinter::ClearBuffer | ( | bool | resetToFirstElement = true | ) |
| inline

If in print to memory mode, reset the buffer to the beginning.

## ◆ CStr()

const char * tinyxml2::XMLPrinter::CStr | ( |  | ) | const
| inline

If in print to memory mode, return a pointer to the XML file in memory.

## ◆ CStrSize()

int tinyxml2::XMLPrinter::CStrSize | ( |  | ) | const
| inline

If in print to memory mode, return the size of the XML file in memory. (Note the size returned includes the terminating null.)

## ◆ OpenElement()

void tinyxml2::XMLPrinter::OpenElement | ( | const char * | name,
|  | bool | compactMode = false )

If streaming, start writing an element. The element must be closed with CloseElement()

## ◆ PrintSpace()

virtual void tinyxml2::XMLPrinter::PrintSpace | ( | int | depth | ) |
| protectedvirtual

Prints out the space before an element. You may override to change the space and tabs used. A PrintSpace() override should call Print().

## ◆ PushHeader()

void tinyxml2::XMLPrinter::PushHeader | ( | bool | writeBOM,
|  | bool | writeDeclaration )

If streaming, write the BOM and declaration.

The documentation for this class was generated from the following file:

- tinyxml2.h